'Placed in the Public Domain 5/24/97   John E. Carter
'johnecarter@mindspring.com
'
'requires PowerBasic 2.1 or higher to compile
'
'dloadcc.bas - Version 0.4 - 11/27/92
'version 0.4 11/27/92 - changed info on screen: "Program type" to "File type"
'                       "File type" to "File format".
'                     - Added display of drive and directory.
'version 0.3 07/12/92 - added "Q" to exit at first prompt
'version 0.2 07/03/92 - erased "DLOADDIR" line on first request from Coco
'                     - added a wait after each 15 lines of 'dloaddir.bas'
'version 0.1 01/17/92 - initial version
'PowerBASIC Version Copyright (c) 1992 by John E. Carter
'serves as host for the Radio Shack (Tandy) Color Computer (COCO)
'DLOAD "FILENAME", speed  (0 = 300 baud, 1 = 1200 baud) command
'COCO files can be stored on a PC host and downloaded at 1200 baud
'they can then be saved to disk or tape
'supports BASIC and machine language program transfer
'BASIC can be transferred in BINARY (tokenized) or ASCII format
'based on a document from RS Customer Service, downloaded from CompuServe
' In the real world, only ASCII transfers work :-(
$LIB GRAPH OFF
$COM 8192
on error goto errhandler
defint a-z
'define the fixed items
%FILEREQ = &H8A
%BLOCKREQ = &H97   '&H96 in later versions?
%ACK = &HC8
%ABORT = &HBC
%BADCHECK = &HDE
%BASIC = &H00
%ML = &H02
%NOTFOUND = &HFF
%ASCII = &HFF
%BINARY = &H00
%EOF = &H00
SHARED chk$, reqname$, reqok, sendok, filelist$(), fileext$(), cps
%FILEMAX = 200
dim filelist$(%FILEMAX),fileext$(%FILEMAX)    'probably larger than needed
dr$=""
pth$=""
cls
locate 2,32
print "CoCo Downloader"
locate 4,20
print "Press Alt-E to abort a transfer in progress"
locate 6,20
print "or to exit when transfer(s) complete"
locate 8, 1
print "Drive with CoCo files (A/B/C/D) or RETURN for current drive (Q to quit): ";
cpos = pos(0)
input "",dr$
if ucase$(dr$) = "Q" then end
dr$ = ucase$(ltrim$(rtrim$(dr$)))
if len(dr$) then
  dr$ = left$(dr$,1) + ":"
  chdrive dr$
else
  dr$ = left$(curdir$,2)
end if
locate 8,cpos
print dr$
print "Path to CoCo files (\dir\subdir) or RETURN for current directory: ";
clin = csrlin
cpos = pos(0)
input "",pth$
pth$ = ucase$(ltrim$(rtrim$(pth$)))
locate clin,cpos
if len(pth$) then
  print pth$
  chdir pth$
  pth$ = dr$ + pth$
else
  pth$ = curdir$
  print right$(pth$,len(pth$)-2)
'  dr$=""
end if
k$ = dir$("*.*")
if len(k$) < 1 then
  print:print "No files found in current directory"
  end
end if
filnum = 1
print "Building directory of files in ";pth$
k$ = dir$("*.*")
while len(k$) > 0
  dotloc = instr(k$,".")
  if dotloc then
    filelist$(filnum) = left$(k$,dotloc -1)
    fileext$(filnum) =  right$(k$,len(k$) -dotloc)
  else
    filelist$(filnum) = k$
    fileext$(filnum) = "   "
  end if
  incr filnum
  k$ = dir$
wend
for k = filnum to %FILEMAX
  filelist$(k) = "zzzzzzzz"
next k
'put the filenames in alpha order
array sort filelist$(), tagarray fileext$()
'create an ASCII basic program that runs on the CoCo to show what's on the host
open "dloaddir.bas" for output as 1
print #1,"1 CLS"
for k = 1 to filnum -1
  print #1, k+10;" ? ";chr$(34);filelist$(k);
  if len(rtrim$(fileext$(k))) > 0 then
    print #1,".";fileext$(k);
  end if
  if (k/30) = int(k/30) then
    print #1,chr$(34);",";
    print #1,": INPUT ";chr$(34);"PRESS ENTER FOR MORE ";chr$(34);";QQ$:CLS"
  else
    print #1,chr$(34);","
  end if
next k
print #1, k+10;" ?"
close 1
clin = csrlin
cpos = pos(0)
getport:
input "Serial port to use (1*/2/3/4): ",port$  ' defaults marked with *
port$ = ltrim$(rtrim$(port$))
if port$ = "" then
  port$ = "1"
else
  port$ = ltrim$(rtrim$(port$))
  if instr(port$,any "1234") = 0 then
    beep
    locate clin, cpos
    goto getport
  end if
end if
slin = csrlin
spos = pos(0)
getspeed:
input "300 or 1200 baud (3/1*): ",speed$
speed$ = ltrim$(rtrim$(speed$))
if speed$ = "3" then
  speed$ = "300"
  cps = 27
else
  if (speed$ = "1") or (speed$ = "") then
    speed$ = "1200"
    cps = 80
  else
    beep
    locate slin,spos
    goto getspeed
  end if
end if
locate clin, cpos
print space$(79)
print "Using com port ";port$;" at ";speed$;" baud"
dostr$ = "COM" + port$  + ":" + speed$ + ",n,8,1,cd"
open dostr$ as 1 len = 8192
locate 16,10
print "Type 'DLOAD ";chr$(34);"filename";chr$(34);
if speed$ = "300" then print ",0";
print "' at CoCo keyboard"
locate 18,5
x$ = "DLOAD "+chr$(34)+"DLOADDIR"+chr$(34)+" and RUN it for a list of the files in "+pth$
print x$
while (1)                                   'loop forever
  while not instat                          'if no key pressed
    if loc(1) > 0 then                      'if characters in the buffer
       m$ = input$(1,#1)
	select case ascii(m$)
	  case %FILEREQ                    'start of request (sync?)
	    locate 18,5
	    print space$(70);
	    locate 16,10
	    print "Got request";space$(20)
	    call getname
	    if reqok = 1 then              'filename received OK
	      call sendfile
	      locate 23,34
	      print time$;
	      if sendok then
		locate 16,10
		print "Send successfully completed";space$(35)
	      end if
	      delay 2
	      for q = 13 to 22
		locate q,1
		print space$(79)
	      next q
	      locate 16,10
	      print "Type 'DLOAD ";chr$(34);"filename";chr$(34);",";
	      if speed$ = "1200" then print "1"; else print "0";
	      print "' at CoCo keyboard"
	    else
	      print #1, chr$(%BADCHECK);   'bad checksum
	    end if
	end select
    end if
  wend
  while instat
    myinput$ = inkey$
    if len(myinput$) = 2 then
      myinput$ = right$(myinput$,1)
      if myinput$ = chr$(18) then                        'Alt-E (exit)
	clin = csrlin
	cpos = pos(0)
	locate 23,1
	print space$(60);
	locate clin, cpos
	close
	print
	print "Terminated"
	end
      end if
    end if
  wend
wend
end

DEF FNchecksum(chk$)
  chk = 0
  for k = 1 to len(chk$)
    chk = chk xor ascii(mid$(chk$,k,1))
  next k
  FNchecksum = chk
END DEF

SUB getname
  print #1, chr$(%FILEREQ);
  chk$ = ""
  while len(chk$) < 9                     'get 8 byte name and checksum
    m$ = input$(1, #1)
    if ascii(m$) = %ABORT then
      locate 16,10
      print "Aborted by receiver"
      exit sub
    end if
    chk$ = chk$ + m$
  wend
  chkbyte$ = right$(chk$,1)               'get checksum
  cococheck = ascii(chkbyte$)
  chk$ = left$(chk$,8)
  mychk = FNchecksum(chk$)
  if mychk = cococheck then
    reqok = 1
    reqname$ = rtrim$(chk$)
  else
    reqok = 0
  end if
END SUB

SUB sendfile
  SHARED reply$
  locate 23,1
  print space$(50);
  array scan filelist$(), = reqname$, to thisone%
  if thisone% = 0 then
    locate 16,10
    print "File ";reqname$;" not found";space$(30)
    sendok = 0
    reply$ = chr$(%NOTFOUND) + chr$(%ASCII)
    chkchar = FNcheckbyte(reply$)
    print #1, chr$(ACK);reply$;chr$(chkchar);
    exit sub
  else
    decr thisone%
  end if
  locate 13,10
  print "CoCo requested ";reqname$;".  ";
  print "Sending ";reqname$;".";rtrim$(fileext$(thisone%))
  locate 16,10
  print "CoCo requested block: ";
  rlin = csrlin
  rpos = pos(0)
  print space$(40);
  locate 16,50
  print "Sending block: ";
  bline = csrlin
  bpos = pos(0)
  inf$ = filelist$(thisone%) + "." + fileext$(thisone%)
  close 2
  open inf$ for binary as 2
  xmitsec& = lof(2) / cps
  if xmitsec& > 60 then
    xmitmin = int(xmitsec&/60)             'get minutes
    xmitsec& = xmitsec& - (xmitmin * 60)    'get remaining seconds
  else
    xmitmin = 0
  end if
  if right$(fileext$(thisone%),3) <> "BIN" then
    filetype = %BASIC
    get$ 2,1,x$
    if ascii(x$) = &HFF then
      f.asc = %BINARY
    else
      f.asc = %ASCII
    end if
    if f.asc = %ASCII then seek 2,0
  else
    f.asc = %BINARY
    filetype = %ML
  end if
  reply$ = chr$(filetype) + chr$(f.asc)
  chk = FNcheckbyte(reply$)
  print #1, chr$(%ACK);reply$;chr$(chk);

  bytes = 0
  block = 0
  locate 18,40
  print "of ";lof(2)
  print "Transfer time: ";ltrim$(str$(xmitmin,3));":";ltrim$(str$(xmitsec&,2))
  print "File type: ";
  if filetype = %ML then print "ml"; else print "basic";
  print "    File format: ";
  if f.asc = %ASCII then print "ascii" else print "binary"
  locate 23,1
  print "Start: ";time$,"End: ";
  tlin = csrlin
  tpos = pos(0)
  while 1  'eof(2) <> -1
206 rem ?"line 206"
    timstart& = timer
    m$ = ""
    while len(m$) = 0
      if timer - timstart& > 10 then
	close 2
	locate 16,10
	print "Timed out waiting for response";space$(30)
	sendok = 0
	exit sub
      end if
      m$ = input$(loc(1),#1)        	  'get next byte
    wend
    timstart& = timer
207 locate 18,1:?"file req = ";hex$(ascii(m$));
    if ascii(m$) = %ABORT then
      close 2
      locate 20,10
      print "I/O Error"
      sendok = 0
      exit sub
    end if
    if ascii(m$) = %BLOCKREQ then
      print #1, chr$(%BLOCKREQ);
      chk$ = ""
      while len(chk$) < 3
	if timer - timstart& > 10 then
	  close 2
	  locate 16,10
	  print "Timed out waiting for response";space$(30)
	  sendok = 0
	  exit sub
	end if
	m$ = input$(1,#1)     'loc(1),#1)
208	'locate 18,20:?"m$=";hex$(ascii(m$));
	chk$ = chk$ + m$
      wend
      chkbyte$ = right$(chk$,1)               'get checksum
      cococheck = ascii(chkbyte$)
      chk$ = left$(chk$,2)
      mychk = FNchecksum(chk$)
      if mychk <> cococheck then
	print #1, chr$(%BADCHECK);
	goto 206
      end if
      reqblock = ascii(right$(chk$,1)) + (ascii(left$(chk$,1)) * 128)
      locate rlin, rpos
      print reqblock;
      if reqblock <> block then
	print #1,lastreply$;
	goto 206
      end if
      if seek(2) <> lof(2) then
	locate bline, bpos
	print block;
	get$ 2, 128, x$
	if (filtype = %BASIC) and (f.asc = %ASCII) then
	  nl = instr(x$, chr$(0))    'null in ascii file is EOF marker
	  if nl then
	    x$ = left$(x$, nl -1)    'trim string to just valid chars
	    if right$(x$,1) <> chr$(13) then x$ = x$ + chr$(13) 'add CR
	    seek 2, lof(2)           'skip to EOF
	  end if
	end if
	xl = len(x$)
	incr bytes, xl
	locate 18,20:print "bytes ="bytes;
	if xl < 128 then
	  if (filtype = %BASIC) and (f.asc = %ASCII) then
	    if right$(x$,1) <> chr$(13) then x$ = x$ + chr$(13)
	    incr xl
	  end if
	  x$ = x$ + space$(128 -xl)
	end if
	reply$ = chr$(xl) + x$
	chk = FNcheckbyte(reply$)
	print #1,chr$(%ACK);reply$;chr$(chk);
	lastreply$ = chr$(%ACK)+reply$+chr$(chk)
	incr block
      else
	locate bline, bpos
	print block
	reply$ = chr$(0) + string$(128,0)  'space$(128)
	chk = FNcheckbyte(reply$)
	print #1,chr$(%ACK);reply$;chr$(chk);
	locate tlin, tpos
	print time$
	beep:beep
	goto 299
      end if
    end if
  wend
299  sendok = 1
END SUB

DEF FNcheckbyte(reply$)
  ck = 0
  for k = 1 to len(reply$)
    ck = ck xor ascii(mid$(reply$,k,1))
  next k
  FNcheckbyte = ck
END DEF

errhandler:
  tmperr = err
  tmpline = erl
  tmpadr = eradr
  if tmperr = 24 then
    print "Timeout error opening com port ";port$;"."
    print "Check connections and press return or enter Q to quit.";
    input " ",q$
    if ucase$(q$) = "Q" then print "Program terminated":end
    resume
  end if
  if tmperr = 25 then
    print "Device error opening com port ";port$;"."
    print "Check connections and press return or enter Q to quit.";
    input " ",q$
    if ucase$(q$) = "Q" then print "Program terminated":end
    resume
  end if
  if tmperr = 68 then
    print "Your computer does not have a com port ";port$;"."
    print "Re-start program and use a valid com port number."
    print "Program terminated"
    end
  end if
  if tmperr = 71 then
    print "Disk ";dr$;" is not ready."
    print "Check drive ";dr$;" and press return when ready.";
    input "",q$
  end if
  if tmperr = 72 then
    print "The disk in drive ";dr$;" is unreadable."
    print "Check the disk in drive ";dr$; " and re-start program."
    end
  end if
  print "Error ";tmperr;" encountered at line ";tmpline;" address ";tmpadr
  end
